﻿using System;
using System.Runtime.InteropServices;
using System.ComponentModel;
using System.Threading.Tasks;
using System.Windows.Forms;
using AddinExpress.MSO;
using Microsoft.Graph;
using Microsoft.IdentityModel.Clients.ActiveDirectory;
using Application = System.Windows.Forms.Application;
using Excel = Microsoft.Office.Interop.Excel;

namespace Excel_O365
{
    /// <summary>
    ///   Add-in Express Add-in Module
    /// </summary>
    [GuidAttribute("2D20361E-7EF6-4C51-AB2A-81014B5B3E93"), ProgId("Excel_O365.AddinModule")]
    public partial class AddinModule : AddinExpress.MSO.ADXAddinModule
    {
        public AddinModule()
        {
            Application.EnableVisualStyles();
            InitializeComponent();
            // Please add any initialization code to the AddinInitialize event handler
        }

        #region Add-in Express automatic code

        // Required by Add-in Express - do not modify
        // the methods within this region

        public override System.ComponentModel.IContainer GetContainer()
        {
            if (components == null)
                components = new System.ComponentModel.Container();
            return components;
        }

        [ComRegisterFunctionAttribute]
        public static void AddinRegister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXRegister(t);
        }

        [ComUnregisterFunctionAttribute]
        public static void AddinUnregister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXUnregister(t);
        }

        public override void UninstallControls()
        {
            base.UninstallControls();
        }

        #endregion

        public static new AddinModule CurrentInstance
        {
            get
            {
                return AddinExpress.MSO.ADXAddinModule.CurrentInstance as AddinModule;
            }
        }

        public Excel._Application ExcelApp
        {
            get
            {
                return (HostApplication as Excel._Application);
            }
        }
        
 private void adxGetProfileInfoRibbonButton_OnClick(object sender, IRibbonControl control, bool pressed)
        {
            Excel.Range currSelection = null;
            try
            {
                var client = new GraphService(new Uri("https://graph.microsoft.com/beta/[tenant-id]"), GetUserToken);
                IUser user = client.Me.ExecuteAsync().Result;
                var name = user.displayName;
                currSelection = ExcelApp.Selection as Excel.Range;
                currSelection.Value2 = name;
            }
            finally
            {
                if (currSelection != null)
                    Marshal.ReleaseComObject(currSelection);
            }
        }

        private Task<string> GetUserToken()
        {
            var authContext = new AuthenticationContext("https://login.microsoftonline.com/common", false);
            var authResult = authContext.AcquireToken(
                "https://graph.microsoft.com", 
                "98651301-70ac-481f-9a3b-4a2ade1e3132", 
                new Uri("http://myapp"), 
                PromptBehavior.Auto);

            var userToken = authResult.AccessToken;
            return Task.FromResult(userToken);
        }



    }
}

